
#include <string.h>	

#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/pgmspace.h>
#include <avr/wdt.h>
#include <stdlib.h>
#include <portbits.h>

#include <math.h>
#include <util/delay.h>


#include "param.h"
#include "global.h"
#include "lcd.h"
#include "uart.h"


//*****INCLUD-FILES FOR SD-CARD*********
#include "dos.h"			
#include "fat.h"			
#include "dosdefs.h"						
#include "mmc_spi.h"
#include "find_x.h"		
#include "savetext.h"
#include "savebmp.h"

//*****INCLUD-FILES FOR SD-CARD*********

#include "fontsoftape.h"

#include "bitmap.h"
#include "oh640x63.h"
#include "taster_1.h"
#include "Schalt.h"
#include "Rgb.h"
#include "simson.h"




//***************************************************************************
//*																			*
//*					LCD Controller fr Dualscan 640x480 LCD					*
//*																			*
//*								mit UART									*
//*																			*
//*								Version 1.00								*
//*																			*
//*								 by Benedikt								*
//*																			*
//*						Email:	benedikt83 t gmx.net						*
//*																			*
//***************************************************************************
//*																			*
//*	Die Software darf frei kopiert und verndert werden, solange sie nicht	*
//*	ohne meine Erlaubnis fr kommerzielle Zwecke eingesetzt wird.			*
//*																			*
//***************************************************************************

#define UART_BAUD_RATE		   57600 






int main(void)
{	PORTD=1;
	//DDRB=255;
	DDRB = 0xFF;// Ausgang
	DDRD=254;
	DDRE=255;
	PORTA=255;
	PORTC=255;

	uart_init(UART_BAUD(UART_BAUD_RATE, F_CPU),UART_BAUD_U2X(UART_BAUD_RATE, F_CPU));
	lcd_init();									// LCD Controller initialisieren
	
	
	
	
	
	
	unsigned char c;
	unsigned char FontX=0, FontY=0 ;
	unsigned short xpos=0, ypos=0,sinx=250;



 LoadBitmap_P(oh640x63bmp, 0 ,0, 640,63 );   //Bitmap fllt ganzes Display


  Delay1ms(3000);




LoadBitmap_P(Schaltbmp, 0 ,63, 640,177 );   //Bitmap fllt ganzes Display

   Delay1ms(3000);

LoadBitmap_P(RGBbmp, 0 ,239, 640,177 );   //Bitmap fllt ganzes Display

  Delay1ms(3000);


LoadBitmap_Po64(tasterbmp1, 0 ,416, 640,63 );   //Bitmap fllt ganzes Display

  Delay1ms(3000);

 

	SetFont(11);
    LCDSoftText("100%",230,123);

//********************************************************************************



LoadBitmap_Po64( simsonbmp, 195 ,200, 240,64 );   //Bitmap fllt ganzes Display



//*******************************************************
//*******************************************************


 MMC_IO_Init();




//********************************************************** 
//********************************************************** 

//TEXT STRING SPEICHER AUF DER SD-KARTE
 SaveTextDisplay("pwm.txt","HELLIGKEITS-WERTE ALLER DIMMKANLE");
 SaveTextDisplay("pwm.txt","12.00.00UHR");


//VARIABLE (ZAHL,ZEICHEN) SPEICHER AUF DER SD-KARTE
sinx=10;
SaveTextDisplay_c ("pwm.txt",sinx);
sinx=20;
SaveTextDisplay_c ("pwm.txt",sinx);
sinx=30;
SaveTextDisplay_c ("pwm.txt",sinx);
sinx=40;
SaveTextDisplay_c ("pwm.txt",sinx);
sinx=50;
SaveTextDisplay_c ("pwm.txt",sinx);
sinx=60;
SaveTextDisplay_c ("pwm.txt",sinx);
sinx=70;
SaveTextDisplay_c ("pwm.txt",sinx);
sinx=80;
SaveTextDisplay_c ("pwm.txt",sinx);
SaveTextDisplay("pwm.txt","Made by KAY BOHN");

//********************************************************** 
//**********************************************************  



 Delay1ms(3000);
 
 

 
 
 // Schreibe Bilder einer Bitmap die pixelweise nach rechts geschoben wird
//BITMAP SCHREIBEN 
//********************************************************** 
//**********************************************************  

 unsigned char i,j,tmp,num2,num1,num0;
 char bmpname [] = {'b','m','p','0','0','0','.','b','m','p'};
 char tmpc [] = {'0','0','0','\0'};

 Mkdir("Bilder");   // if you want to save A LOT of screens use a subdirectory !
 Chdir("Bilder");   // change to bitmaps subdirectory

lcd_clear();
 LCDSoftText("Run animation nach x+",0,100); //Text auf dem Textdisplay
 Delay1ms(3000);
// Schreibe Bilder einer Bitmap die pixelweise nach links geschoben wird
 for(i=LCD_WIDTH; i>0; i--)
 //  for(i=0; i<LCD_WIDTH; i++)
  {
 
 LoadBitmap_Po64(simsonbmp, i , 0, 240, 64);
   tmp=i;
   num0=(unsigned char)(tmp%10);
   bmpname[5] = (char) (num0 + '0');
   tmpc[2] = bmpname[5];
   tmp /= 10;
   num1=(unsigned char)(tmp%10);
   bmpname[4] = (char) (num1 + '0');
   tmpc[1] = bmpname[4];
   tmp /= 10;
   num2=(unsigned char)(tmp);
   bmpname[3] = (char) (num2 + '0');
   tmpc[0] = bmpname[3];
   
 LCDSoftText(tmpc,0,100);
 //SaveGraphDisplay(bmpname,G_BASE);
 
}





 LCDSoftText("LADE BILD",0,85); //Text auf dem Textdisplay
 Delay1ms(3000);
 
 
 for(i=0; i<241; i++)
  {
   tmp=i;
   num0=(unsigned char)(tmp%10);
   bmpname[5] = (char) (num0 + '0');
   tmpc[2] = bmpname[5];
   tmp /= 10;
   num1=(unsigned char)(tmp%10);
   bmpname[4] = (char) (num1 + '0');
   tmpc[1] = bmpname[4];
   tmp /= 10;
   num2=(unsigned char)(tmp);
   bmpname[3] = (char) (num2 + '0');
   tmpc[0] = bmpname[3];
   LCDSoftText(tmpc,0,100); //Text auf dem Textdisplay

   LoadGraphDisplay(bmpname,G_BASE);
  }

 
 

 
 

Delay1ms(3000);





 LCDSoftText("Run animation nach y-",0,100); //Text auf dem Textdisplay
 Delay1ms(3000);
// Schreibe Bilder einer Bitmap die pixelweise nach rechts geschoben wird
 for(i=0; i<LCD_WIDTH; i++)
  {
 
 LoadBitmap_Po64(simsonbmp, 239 , i,240, 64);

}









lcd_clear();

Delay1ms(3000);












lcd_clear();

Delay1ms(3000);
LoadTextDisplay();

Delay1ms(3000);

Delay1ms(3000);

LoadTextDisplay_xy ("test.txt");

Delay1ms(3000);




//#########################################################################
// Lese einen Text von der SD-Karte und zeige ihn an x und y position an
// in der Aufruf Routine muss die zeichen-Lnge Definiert werden
LoadTextDisplay_xpyp ("pwm.txt",10,10);
//#########################################################################


Delay1ms(3000);


   LCDSoftText("ENDE DER VOTRSTELLUNG",80,100); //Text auf dem Textdisplay


//#########################################################################
//#########################################################################
//#########################################################################
//#########################################################################
//#########################################################################




	for (;;)
	{	c = uart_getchar();
		if (c>31)				//Display Text
		{
		LCDSoftCharProp(c,xpos,ypos);//xpos,ypos);
			xpos+=FontX;
			if (xpos>=XSIZE)
			{	xpos=0;
				ypos+=FontY;
				if (ypos>=YSIZE)
					ypos=0;
			}
		}








		else if (c==1)			// Cursor Home
		{	xpos=0;
			ypos=0;
		}
		
		else if (c==2)			// GLCD FUNKTIONEN
		{   c=uart_getchar();
            if (c==1)			// GLCD ON
            ENABLE_VLCD=1;
		}
		    if (c==2)			// GLCD OFF
		{   ENABLE_VLCD=0;
		
		}		 
		    
            if (c==3)			// GLCD BACKLIGHT ON
		{   ENABLE_Backlight=1;
		
		}
		
            if (c==4)			// GLCD BACKLIGHT OFF
		{   ENABLE_Backlight=0;
		
		}

		/*else if (c==3)			// GLCD WINDOW FUNKTIONEN
		{   c=uart_getchar();
            if (c==180)			// GLCD WINDOW 1
            //lcd_setsite1(0, 0,0 );
		}
		    if (c==181)			// GLCD WINDOW 2
		{   //lcd_setsite2(0, 0,0 );
		
		}		 
		    
            if (c==182)			// GLCD WINDOW 3
		{   //lcd_setsite1(0, 0,0 );
		
		}
		
            if (c==183)			// GLCD WINDOW 4
		{   //lcd_setsite1(0, 0,0 );
		
		}
		*/
		else if (c==4)			// 
		{	
		   
		}
		else if (c==5)			// 
		{			
		
		    
		}
		else if (c==8)			// Backspace
		{	xpos-=TEXT_X;
			if (xpos>=32768)
			{	xpos=XSIZE-TEXT_X;
				ypos-=TEXT_Y;
				if (ypos>=32768)
					ypos=YSIZE-TEXT_Y;
			}
			lcd_writechar(xpos/4,ypos,32);
		}
		else if (c==9)			// Set Pixel
		{	CONVERTW x,y;
			x.b[0]=uart_getchar();
			x.b[1]=uart_getchar();
			y.b[0]=uart_getchar();
			y.b[1]=uart_getchar();
			c=uart_getchar();
			lcd_setpixel(x.w,y.w,c);
		}
		else if (c==10)        // Line Feed
		{	ypos+=TEXT_Y;
			if (ypos>=YSIZE) 
				ypos=0;
		}
		else if (c==11)        // Delete in place
		{	lcd_writechar(xpos/4,ypos,32);
		}
		else if (c==12)        // Form Feed
		{	xpos=0;
			ypos=0;
			lcd_clear();
		}
		else if (c==13)			// Carriage Return
		{	xpos=0;
		}
		else if (c==14)			// Set Brightness
		{	c=uart_getchar();
		}
		else if (c==15)			// Set Contrast
		{	c=uart_getchar();
			if (c>100)
				c=100;
			OCR1B=c*2+c/2;
		}	
		else if (c==16)			//Load BMP
		{	CONVERTW y1,ys;
			unsigned short y;
			unsigned char x1,xs,x,c;
			if (uart_getchar()==0xAA)
			{	x1=uart_getchar();
    			y1.b[0]=uart_getchar();
    			y1.b[1]=uart_getchar();
    			xs=uart_getchar();
    			ys.b[0]=uart_getchar();
    			ys.b[1]=uart_getchar();
    			for (y=0; y<ys.w; y++)
    			{	for (x=0; x<xs; x++)
    				{	c=uart_getchar();
    					lcd_writebyte(x*2+x1,y+y1.w,c,0);
    				}
				}
			}
		}
		else if (c==17)        // Set Cursor Position (Column and Row)
		{	CONVERTW y;
			xpos=uart_getchar();
			y.b[0]=uart_getchar();
			y.b[1]=uart_getchar();
			ypos=y.w;
        }

		else if (c==18)			// SET FONT
		{ c=uart_getchar();

		 if (c==1)			// Cursor Home
		{SetFont(6);
		 FontX = TEXT_X2;
         FontY = TEXT_Y2;
		}		 
		 if (c==2)			// Cursor Home
		    { SetFont(7);
		      FontX = TEXT_X2;
              FontY = TEXT_Y2;
		}
		 if (c==3)			// Cursor Home
		    { SetFont(8);
		      FontX = TEXT_X3;
              FontY = TEXT_Y3;
        xpos=xpos*5;//TEXT_X3;
		
		if (c==4)			// Cursor Home
		    {
		}


		    }		 		 
	    }		 
		else if (c==19)			// Draw Line
		{	CONVERTW x1,y1,x2,y2;
			x1.b[0]=uart_getchar();
			x1.b[1]=uart_getchar();
			y1.b[0]=uart_getchar();
			y1.b[1]=uart_getchar();
			x2.b[0]=uart_getchar();
			x2.b[1]=uart_getchar();
			y2.b[0]=uart_getchar();
			y2.b[1]=uart_getchar();
			lcd_line (x1.w,y1.w,x2.w,y2.w,c);
		
		
		
		}
		else if (c==20)				// Draw Circle
		{	CONVERTW x,y;
			unsigned char c2,r;
			x.b[0]=uart_getchar();
			x.b[1]=uart_getchar();
			y.b[0]=uart_getchar();
			y.b[1]=uart_getchar();
			r=uart_getchar();
			c=uart_getchar();
			c2=uart_getchar();
			lcd_circle (x.w,y.w,r,c,c2);
		

		}
		else if (c==21)			// Scroll
		{	uart_getchar();
			uart_getchar();
		}
		else if (c==22)			// Enable Scroll
		{	uart_getchar();
			uart_getchar();
			uart_getchar();
		
		}
		else if (c==25)				// Get CGRAM
		{	c=uart_getchar();
			c&=7;
			for (unsigned char i=0; i<8; i++)
				cgram[c][i]=uart_getchar();
		}
		

		
		else if (c==28)			// Large Number
		{	uart_getchar();
			uart_getchar();
			uart_getchar();
		}
		else if (c==29)				// Draw Block
		{	CONVERTW x1,x2,y1,y2;
			unsigned char c2;
			x1.b[0]=uart_getchar();
			x1.b[1]=uart_getchar();
			y1.b[0]=uart_getchar();
			y1.b[1]=uart_getchar();
			x2.b[0]=uart_getchar();
			x2.b[1]=uart_getchar();
			y2.b[0]=uart_getchar();
			y2.b[1]=uart_getchar();
			c=uart_getchar();
			c2=uart_getchar();
			lcd_block (x1.w,y1.w,x2.w,y2.w,c,c2);
		}
		else if (c==30)			// Send directly
		{	c=uart_getchar();
			if (c==0)
				lcd_writecgram(xpos/4,ypos,uart_getchar());
			else
				lcd_writechar(xpos/4,ypos,uart_getchar());
   			xpos+=TEXT_X;
   			if (xpos>=XSIZE)
   			{	xpos=0;
   				ypos+=TEXT_Y;
   				if (ypos>=YSIZE)
   					ypos=0;
			}
		}
	}
}


//###################################################################################
//Nicht sonderlich genau !!
void Delay1ms(unsigned int time)
//###################################################################################
{
 unsigned int i;

 for(i=0; i<time; i++) _delay_ms(1);
}

//###################################################################################
//TEST-DATEI-SCHREIBEN !!
void Writtingsd()
//###################################################################################
{

//TEST DATEI ANLEGEN GEHT ERSTMAL 
 unsigned int buf=12345;
 char string[10];
 unsigned int written;
 utoa (buf,string,10);
 
 if(GetDriveInformation()!=F_OK) // get drive parameters
  {
   // Gib hier eine Fehlermeldung raus
     LCDSoftText("no SD-card_0",1,1); 
  // while(1);
  }
          if(Fopen("kay.txt",'a')==F_OK)  // Datei ffnen oder anlegen
           {
            written=Fwrite((unsigned char *)string,strlen(string));     // Puffer in SD schreiben
            Fclose();
			LCDSoftText("DATEI GESCHRIEBEN_0",1,1);  //MELDUNG AUSGEBEN DATEI GESCHRIEBEN
           }
}
//*******************************************************
//*******************************************************

/*

//###################################################################################
//TEST-DATEI-SCHREIBEN !!
void Writtingsd_c()
//###################################################################################
{

//TEST DATEI ANLEGEN GEHT ERSTMAL 
unsigned int buf=67899;
 char string[10];
 unsigned int written;
 utoa (buf,string,10);
 
 if(GetDriveInformation()!=F_OK) // get drive parameters
  {
   // Gib hier eine Fehlermeldung raus
     LCDSoftText("no SD-card_1",1,1); 
  // while(1);
  }
          if(Fopen("kaya.txt",'a')==F_OK)  // Datei ffnen oder anlegen
           {
            written=Fwrite((unsigned char *)string,strlen(string));     // Puffer in SD schreiben
            Fclose();
			LCDSoftText("DATEI GESCHRIEBEN_1",1,1);  //MELDUNG AUSGEBEN DATEI GESCHRIEBEN
           }
}
//*******************************************************
//*******************************************************



//###################################################################################
//TEST-DATEI-SCHREIBEN !!
void Writtingsd_b()
//###################################################################################
{

//TEST DATEI ANLEGEN GEHT ERSTMAL 
unsigned int buf=12345;
 char string[10];
 unsigned int written;
 utoa (buf,string,10);
 
 if(GetDriveInformation()!=F_OK) // get drive parameters
  {
   // Gib hier eine Fehlermeldung raus
     LCDSoftText("no SD-card_1",1,1); 
  // while(1);
  }
          if(Fopen("kay.bmp",'a')==F_OK)  // Datei ffnen oder anlegen
           {
            written=Fwrite((unsigned char *)string,strlen(string));     // Puffer in SD schreiben
            Fclose();
			LCDSoftText("BMP GESCHRIEBEN_1",1,1);  //MELDUNG AUSGEBEN DATEI GESCHRIEBEN
           }
}


/*
//###################################################################################
//TEST-DATEI-SCHREIBEN !!
unsigned char SaveTextDisplay(char *name)
//###################################################################################
{

//TEST DATEI ANLEGEN GEHT ERSTMAL 
unsigned int buf=12345;
 char string[10];
 unsigned int written;
 utoa ( buf,string,10);
 
 if(GetDriveInformation()!=F_OK) // get drive parameters
  {
   // Gib hier eine Fehlermeldung raus
     LCDSoftText("KEINE SD-CARD GEFUNDEN",1,1); 
  // while(1);
  }
           if(Fopen(name,F_WRITE)!=F_OK) return 0;
           {



            written=Fwrite((unsigned char *)string,strlen(string));        // Puffer in SD schreiben
            Fclose();
			LCDSoftText("DATEI ANGELGET name",1,1);  //MELDUNG AUSGEBEN DATEI GESCHRIEBEN
           }
}
*/




